'''
Created on 1 févr. 2014

@author: inso
'''

from ucoinpy.api import bma
from ucoinpy.documents.transaction import InputSource
from ucoinpy.key import SigningKey


class Wallet(object):

    '''
    A wallet is list of coins.
    It's only used to sort coins.
    '''

    def __init__(self, walletid, pubkey, currency, name):
        '''
        Constructor
        '''
        self.coins = []
        self.walletid = walletid
        self.pubkey = pubkey
        self.currency = currency
        self.name = name

    @classmethod
    def create(cls, walletid, pubkey, currency, name):
        return cls(walletid, pubkey, currency, name)

    @classmethod
    def load(cls, json_data):
        walletid = json_data['walletid']
        pubkey = json_data['pubkey']
        name = json_data['name']
        currency = json_data['currency']
        return cls(walletid, pubkey, currency, name)

    def __eq__(self, other):
        return (self.keyid == other.keyid)

    def relative_value(self, community):
        value = self.value(community)
        ud = community.dividend()
        relative_value = value / float(ud)
        return relative_value

    def value(self, community):
        value = 0
        for s in self.sources(community):
            value += s.amount
        return value

    def send_money(self, recipient, amount, message):
        pass

    def sources(self, community):
        data = community.request(bma.tx.Sources, req_args={'pubkey': self.pubkey})
        tx = []
        for s in data['sources']:
            tx.append(InputSource.from_bma(s))
        return tx

    #TODO: Build a cache of latest transactions
    def transactions_sent(self):
        return []

    def get_text(self, community):
        return "%s : \n \
%d %s \n \
%.2f UD" % (self.name, self.value(community), self.currency,
                          self.relative_value(community))

    def jsonify(self):
        return {'walletid': self.walletid,
                'pubkey': self.pubkey,
                'name': self.name,
                'currency': self.currency}
